package com.gxwebsoft.cms.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.cms.service.CmsDocsService;
import com.gxwebsoft.cms.entity.CmsDocs;
import com.gxwebsoft.cms.param.CmsDocsParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.system.entity.User;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 文档管理记录表控制器
 *
 * @author 科技小王子
 * @since 2024-09-10 20:47:57
 */
@Api(tags = "文档管理记录表管理")
@RestController
@RequestMapping("/api/cms/cms-docs")
public class CmsDocsController extends BaseController {
    @Resource
    private CmsDocsService cmsDocsService;

    @ApiOperation("分页查询文档管理记录表")
    @GetMapping("/page")
    public ApiResult<PageResult<CmsDocs>> page(CmsDocsParam param) {
        // 使用关联查询
        return success(cmsDocsService.pageRel(param));
    }

    @ApiOperation("查询全部文档管理记录表")
    @GetMapping()
    public ApiResult<List<CmsDocs>> list(CmsDocsParam param) {
        PageParam<CmsDocs, CmsDocsParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(cmsDocsService.list(page.getOrderWrapper()));
        // 使用关联查询
        //return success(cmsDocsService.listRel(param));
    }

    @PreAuthorize("hasAuthority('cms:cmsDocs:list')")
    @OperationLog
    @ApiOperation("根据id查询文档管理记录表")
    @GetMapping("/{id}")
    public ApiResult<CmsDocs> get(@PathVariable("id") Integer id) {
        return success(cmsDocsService.getById(id));
        // 使用关联查询
        //return success(cmsDocsService.getByIdRel(id));
    }

    @ApiOperation("添加文档管理记录表")
    @PostMapping()
    public ApiResult<?> save(@RequestBody CmsDocs cmsDocs) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
          cmsDocs.setUserId(loginUser.getUserId());
        }
        if (cmsDocsService.save(cmsDocs)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("修改文档管理记录表")
    @PutMapping()
    public ApiResult<?> update(@RequestBody CmsDocs cmsDocs) {
        if (cmsDocsService.updateById(cmsDocs)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("删除文档管理记录表")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (cmsDocsService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @ApiOperation("批量添加文档管理记录表")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<CmsDocs> list) {
        if (cmsDocsService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("批量修改文档管理记录表")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<CmsDocs> batchParam) {
        if (batchParam.update(cmsDocsService, "docs_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("批量删除文档管理记录表")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (cmsDocsService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
